import { AudioTrack } from "./audioTrack";

const TIME_STEP = 0.5;

export class AudioPlayer {
	playing: boolean = false;
	playHead: number = 0;
	ctx: AudioContext;
	oscA: OscillatorNode;
	oscB: OscillatorNode;
	g: GainNode;
	constructor() {
		this.ctx = new AudioContext();
		this.oscA = this.ctx.createOscillator();
		this.oscB = this.ctx.createOscillator();
		this.g = this.ctx.createGain();
		this.g.gain.value = 0.05;
		this.oscA.connect(this.g);
		this.oscB.connect(this.g);
		this.oscB.type = "sawtooth";
		this.oscA.type = "sine";
		this.g.connect(this.ctx.destination);
	}
	start(): void {
		this.playNote();
		this.playing = !this.playing;
	}
	tick(): void {}

	playNote(): void {
		this.oscA.frequency.value = 440;
		this.oscB.frequency.value = 523.25;
		this.oscA.start(0);
		this.oscB.start(0);
		this.oscA.stop(TIME_STEP);
		this.oscB.stop(TIME_STEP);
	}
}
