const enum NoteName {
	A,
	As,
	B,
	C,
	Cs,
	D,
	Ds,
	E,
	F,
	Fs,
	G,
	Gs,
}
type NoteTick = {
	name: NoteName;
	octave: number;
	duration: number;
};

function newNote(name: NoteName, octave: number, duration: number): NoteTick {
	return { name, octave, duration };
}

type Noop = 0;

type ChannelTick = NoteTick | Noop;

const enum Instrument {
	Saw = "sawtooth",
	Sine = "sine",
	Square = "square",
	Triangle = "triangle",
}

type AudioChannel = { instrument: Instrument; notes: Array<ChannelTick> };

export class AudioTrack {
	channel: AudioChannel;
	playRate: number = 1;
	constructor() {
		this.channel = {
			instrument: Instrument.Saw,
			notes: [newNote(NoteName.A, 4, 1), 0, newNote(NoteName.B, 4, 1), 0],
		};
	}
	get length(): number {
		return this.channel.notes.length;
	}
}
